Index: drivers/video/fbcon.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/fbcon.c,v
retrieving revision 1.1
retrieving revision 1.4
diff -u -r1.1 -r1.4
--- drivers/video/fbcon.c	22 Jul 2004 19:50:22 -0000	1.1
+++ drivers/video/fbcon.c	7 Oct 2005 21:25:29 -0000	1.4
@@ -34,6 +34,10 @@
  *	2001 - Documented with DocBook
  *	- Brad Douglas <brad@neruo.com>
  *
+ *      2001 - December
+ *      Cursor blink rate sysctl support by Tommi Kyntola <kynde@ts.ray.fi>
+ *      Minor modifications by Eddie Dawydiuk
+ *
  *  The low level operations for the various display memory organizations are
  *  now in separate source files.
  *
@@ -76,6 +80,8 @@
 #include <linux/smp.h>
 #include <linux/init.h>
 #include <linux/pm.h>
+#include <linux/sysctl.h>
+#include <linux/proc_fs.h>
 
 #include <asm/irq.h>
 #include <asm/system.h>
@@ -114,6 +120,8 @@
 #define LOGO_W			80
 #define LOGO_LINE	(LOGO_W/8)
 
+#define CONFIG_FB_DEFAULT_CURSOR_BLINK_RATE 20
+
 struct display fb_display[MAX_NR_CONSOLES];
 char con2fb_map[MAX_NR_CONSOLES];
 static int logo_lines;
@@ -222,6 +230,8 @@
 			    int height, int width, u_int y_break);
 
 static int fbcon_show_logo(void);
+static void fbcon_sysctl_unregister(void);
+static void fbcon_sysctl_register(void);
 
 #ifdef CONFIG_MAC
 /*
@@ -266,23 +276,22 @@
 int PROC_CONSOLE(const struct fb_info *info)
 {
         int fgc;
-        
-        if (info->display_fg != NULL)
-                fgc = info->display_fg->vc_num;
-        else
-                return -1;
-                
-        if (!current->tty)
-                return fgc;
-
-        if (current->tty->driver.type != TTY_DRIVER_TYPE_CONSOLE)
-                /* XXX Should report error here? */
-                return fgc;
 
-        if (MINOR(current->tty->device) < 1)
-                return fgc;
+	if (info->display_fg == NULL)
+		return -1;
+
+        if (!current->tty ||
+	    current->tty->driver.type != TTY_DRIVER_TYPE_CONSOLE ||
+	    MINOR(current->tty->device) < 1)
+		fgc = info->display_fg->vc_num;
+	else
+		fgc = MINOR(current->tty->device)-1;
+
+	/* Does this virtual console belong to the specified fbdev? */
+	if (fb_display[fgc].fb_info != info)
+		return -1;
 
-        return MINOR(current->tty->device) - 1;
+	return fgc;
 }
 
 
@@ -475,6 +484,7 @@
     pm_fbcon = pm_register(PM_SYS_DEV, PM_SYS_VGA, pm_fbcon_request);
 #endif
 
+    cursor_blink_rate = CONFIG_FB_DEFAULT_CURSOR_BLINK_RATE;
     return display_desc;
 }
 
@@ -507,6 +517,8 @@
     conp->vc_display_fg = &info->display_fg;
     if (!info->display_fg)
         info->display_fg = conp;
+
+    fbcon_sysctl_register();
 }
 
 
@@ -515,6 +527,8 @@
     int unit = conp->vc_num;
     struct display *p = &fb_display[unit];
 
+    fbcon_sysctl_unregister();
+
     fbcon_free_font(p);
     p->dispsw = &fbcon_dummy;
     p->conp = 0;
@@ -646,7 +660,9 @@
 	{
 	    /* ++Geert: changed from panic() to `correct and continue' */
 	    printk(KERN_ERR "fbcon_setup: No support for fontwidth %d\n", fontwidth(p));
+
 	    p->dispsw = &fbcon_dummy;
+
 	}
     }
     if (p->dispsw->set_font)
@@ -848,7 +864,6 @@
 
     if (!p->can_soft_blank && console_blanked)
 	    return;
-	    
     if (vt_cons[unit]->vc_mode != KD_TEXT)
     	    return;
 
@@ -919,8 +934,9 @@
 	return;
 
     cursor_on = 0;
-    if (cursor_drawn)
-        p->dispsw->revc(p, p->cursor_x, real_y(p, p->cursor_y));
+    if (cursor_drawn && p->cursor_x < conp->vc_cols &&
+	p->cursor_y < conp->vc_rows)
+	p->dispsw->revc(p, p->cursor_x, real_y(p, p->cursor_y));
 
     p->cursor_x = conp->vc_x;
     p->cursor_y = y;
@@ -944,10 +960,17 @@
 {
     struct display *p;
 
-    if (!cursor_on)
+    /*
+     * Negative cursor_blink_rate will disable cursor completely.
+     * (this single check is actually sufficient, since this way
+     *  the cursor_drawn will never reach nonzero values)
+     * We have to do this check here allow dynamic /proc changes,
+     * and best of all, no sync or locks needed for this approach.
+     */
+     if (!cursor_on || cursor_blink_rate < 0)
 	return;
 
-    if (vbl_cursor_cnt && --vbl_cursor_cnt == 0) {
+     if (vbl_cursor_cnt > 0 && --vbl_cursor_cnt <= 0) {
 	p = &fb_display[fg_console];
 	if (p->dispsw->revc)
 		p->dispsw->revc(p, p->cursor_x, real_y(p, p->cursor_y));
@@ -2124,6 +2147,7 @@
     if (softback_lines && !console_blanked)
         fbcon_scrolldelta(conp, softback_lines);
     return 0;
+
 }
 
 static inline unsigned safe_shift(unsigned d,int n)
@@ -2200,6 +2224,7 @@
 	    int redshift, greenshift, blueshift;
 		
 	    /* Bug: Doesn't obey msb_right ... (who needs that?) */
+
 	    redshift   = p->var.red.offset;
 	    greenshift = p->var.green.offset;
 	    blueshift  = p->var.blue.offset;
@@ -2236,6 +2261,7 @@
 	    else if (depth >= 12 && depth <= 23) {
 	        /* have 4..7 bits per color, using 16 color image */
 		unsigned int pix;
+
 		src = linux_logo16;
 		bdepth = (depth+7)/8;
 		for( y1 = 0; y1 < LOGO_H; y1++ ) {
@@ -2276,14 +2302,17 @@
 	    unsigned char mask[9] = { 0,0x80,0xc0,0xe0,0xf0,0xf8,0xfc,0xfe,0xff };
 	    unsigned char redmask, greenmask, bluemask;
 	    int redshift, greenshift, blueshift;
+
 		
 	    /* Bug: Doesn't obey msb_right ... (who needs that?) */
+
 	    redmask   = mask[p->var.red.length   < 8 ? p->var.red.length   : 8];
 	    greenmask = mask[p->var.green.length < 8 ? p->var.green.length : 8];
 	    bluemask  = mask[p->var.blue.length  < 8 ? p->var.blue.length  : 8];
-	    redshift   = p->var.red.offset   - (8-p->var.red.length);
-	    greenshift = p->var.green.offset - (8-p->var.green.length);
-	    blueshift  = p->var.blue.offset  - (8-p->var.blue.length);
+
+	    redshift   = p->var.red.offset   - (8 - p->var.red.length);
+	    greenshift = p->var.green.offset - (8 - p->var.green.length);
+	    blueshift  = p->var.blue.offset  - (8 - p->var.blue.length);
 
 	    src = logo;
 	    for( y1 = 0; y1 < LOGO_H; y1++ ) {
@@ -2536,6 +2565,41 @@
     revc:	DUMMY,
 };
 
+ctl_table fb_table[] = {
+    {DEV_FB_CURSOR_BLINK_RATE, "cursor_blink_rate", &cursor_blink_rate,
+     sizeof(int), 0666, NULL, &proc_dointvec}, 
+    {0}
+};
+
+ctl_table fb_fb_table[] = {
+    {DEV_FB, "fb", NULL, 0, 0555, fb_table},
+    {0}
+};
+         
+/* Make sure that /proc/sys/dev is there */
+ctl_table fb_root_table[] = {
+    {CTL_DEV, "dev", NULL, 0, 555, fb_fb_table},
+    {0}
+};
+
+static struct ctl_table_header *fb_sysctl_header;
+
+static void fbcon_sysctl_register(void) {
+    static int initialized;   
+    if (initialized == 1)
+        return;
+
+    fb_sysctl_header = register_sysctl_table(fb_root_table, 1);
+    fb_root_table->child->de->owner = THIS_MODULE;
+        
+    initialized = 1;
+}
+
+static void fbcon_sysctl_unregister(void)
+{
+    if (fb_sysctl_header)
+        unregister_sysctl_table(fb_sysctl_header);
+}
 
 /*
  *  Visible symbols for modules
Index: drivers/video/fbmem.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/fbmem.c,v
retrieving revision 1.1
retrieving revision 1.3
diff -u -r1.1 -r1.3
--- drivers/video/fbmem.c	22 Jul 2004 19:50:22 -0000	1.1
+++ drivers/video/fbmem.c	8 Sep 2005 00:38:20 -0000	1.3
@@ -71,6 +71,8 @@
 extern int hitfb_init(void);
 extern int vfb_init(void);
 extern int vfb_setup(char*);
+extern int ts7kvfb_init(void);
+extern int ts7kvfb_setup(char*);
 extern int offb_init(void);
 extern int atyfb_init(void);
 extern int atyfb_setup(char*);
@@ -126,10 +128,11 @@
 extern int sisfb_setup(char*);
 extern int stifb_init(void);
 extern int stifb_setup(char*);
+extern int pmagaafb_init(void);
 extern int pmagbafb_init(void);
 extern int pmagbbfb_init(void);
-extern void maxinefb_init(void);
-extern void ep93xxfb_init(void);
+extern int maxinefb_init(void);
+extern int ep93xx_init(void);
 extern int tx3912fb_init(void);
 extern int radeonfb_init(void);
 extern int radeonfb_setup(char*);
@@ -137,15 +140,19 @@
 extern int intelfb_setup(char*);
 extern int e1355fb_init(void);
 extern int e1355fb_setup(char*);
+extern int e1356fb_init(void);
+extern int e1356fb_setup(char*);
 extern int au1100fb_init(void);
 extern int au1100fb_setup(char*);
 extern int pvr2fb_init(void);
 extern int pvr2fb_setup(char*);
 extern int sstfb_init(void);
 extern int sstfb_setup(char*);
+extern int it8181fb_init(void);
+extern int it8181fb_setup(char*);
 extern int anakinfb_init(void);
 extern int dbmx1fb_init(void);
-  
+
 static struct {
 	const char *name;
 	int (*init)(void);
@@ -164,6 +171,9 @@
 	 * Chipset specific drivers that use resource management
 	 */
 
+#ifdef CONFIG_FB_TS7KV
+	{ "ts7kvfb", ts7kvfb_init, ts7kvfb_setup },
+#endif
 #ifdef CONFIG_FB_RETINAZ3
 	{ "retz3", retz3fb_init, retz3fb_setup },
 #endif
@@ -229,10 +239,10 @@
 #endif
 #ifdef CONFIG_FB_S3TRIO
 	{ "s3trio", s3triofb_init, NULL },
-#endif 
+#endif
 #ifdef CONFIG_FB_FM2
 	{ "fm2fb", fm2fb_init, fm2fb_setup },
-#endif 
+#endif
 #ifdef CONFIG_FB_SIS
 	{ "sisfb", sisfb_init, sisfb_setup },
 #endif
@@ -245,7 +255,7 @@
 
 	/*
 	 * Generic drivers that are used as fallbacks
-	 * 
+	 *
 	 * These depend on resource management and must be initialized
 	 * _after_ all other frame buffer devices that use resource
 	 * management!
@@ -256,7 +266,7 @@
 #endif
 #ifdef CONFIG_FB_VESA
 	{ "vesa", vesafb_init, vesafb_setup },
-#endif 
+#endif
 
 	/*
 	 * Chipset specific drivers that don't use resource management (yet)
@@ -279,7 +289,7 @@
 #endif
 #ifdef CONFIG_FB_HGA
 	{ "hga", hgafb_init, hgafb_setup },
-#endif 
+#endif
 #ifdef CONFIG_FB_IGA
 	{ "igafb", igafb_init, igafb_setup },
 #endif
@@ -294,7 +304,7 @@
 #endif
 #ifdef CONFIG_FB_HP300
 	{ "hpfb", hpfb_init, NULL },
-#endif 
+#endif
 #ifdef CONFIG_FB_G364
 	{ "g364", g364fb_init, NULL },
 #endif
@@ -316,9 +326,15 @@
 #ifdef CONFIG_FB_E1355
 	{ "e1355fb", e1355fb_init, e1355fb_setup },
 #endif
+#ifdef CONFIG_FB_E1356
+        { "e1356fb", e1356fb_init, e1356fb_setup },
+#endif
 #ifdef CONFIG_FB_PVR2
 	{ "pvr2", pvr2fb_init, pvr2fb_setup },
 #endif
+#ifdef CONFIG_FB_PMAG_AA
+	{ "pmagaafb", pmagaafb_init, NULL },
+#endif
 #ifdef CONFIG_FB_PMAG_BA
 	{ "pmagbafb", pmagbafb_init, NULL },
 #endif
@@ -333,7 +349,10 @@
 #endif
 #ifdef CONFIG_FB_AU1100
 	{ "au1100fb", au1100fb_init, au1100fb_setup },
-#endif 
+#endif
+#ifdef CONFIG_FB_IT8181
+	{ "it8181fb", it8181fb_init, it8181fb_setup },
+#endif
 #ifdef CONFIG_FB_DBMX1
 	{ "dbmx1fb", dbmx1fb_init, NULL },
 #endif
@@ -345,7 +364,7 @@
 
 #ifdef CONFIG_FB_VGA16
 	{ "vga16", vga16fb_init, vga16fb_setup },
-#endif 
+#endif
 #ifdef CONFIG_FB_STI
 	{ "stifb", stifb_init, stifb_setup },
 #endif
@@ -362,6 +381,8 @@
 	 */
 	{ "vfb", vfb_init, vfb_setup },
 #endif
+
+
 };
 
 #define NUM_FB_DRIVERS	(sizeof(fb_drivers)/sizeof(*fb_drivers))
@@ -374,7 +395,7 @@
 
 struct fb_info *registered_fb[FB_MAX];
 int num_registered_fb;
-extern int fbcon_softback_size; 
+extern int fbcon_softback_size;
 
 static int first_fb_vc;
 static int last_fb_vc = MAX_NR_CONSOLES-1;
@@ -483,7 +504,7 @@
 }
 #endif /* CONFIG_KMOD */
 
-static int 
+static int
 fb_ioctl(struct inode *inode, struct file *file, unsigned int cmd,
 	 unsigned long arg)
 {
@@ -495,7 +516,7 @@
 	struct fb_fix_screeninfo fix;
 	struct fb_con2fbmap con2fb;
 	int i;
-	
+
 	if (! fb)
 		return -ENODEV;
 	switch (cmd) {
@@ -579,7 +600,7 @@
 	}
 }
 
-static int 
+static int
 fb_mmap(struct file *file, struct vm_area_struct * vma)
 {
 	int fbidx = GET_FB_IDX(file->f_dentry->d_inode->i_rdev);
@@ -670,11 +691,11 @@
 #elif defined(__sh__)
 	pgprot_val(vma->vm_page_prot) &= ~_PAGE_CACHABLE;
 #elif defined(__hppa__)
-	pgprot_val(vma->vm_page_prot) |= _PAGE_NO_CACHE; 
+	pgprot_val(vma->vm_page_prot) |= _PAGE_NO_CACHE;
 #elif defined(__ia64__)
 	vma->vm_page_prot = pgprot_writecombine(vma->vm_page_prot);
 #elif defined(__hppa__)
-	pgprot_val(vma->vm_page_prot) |= _PAGE_NO_CACHE; 
+	pgprot_val(vma->vm_page_prot) |= _PAGE_NO_CACHE;
 #else
 #warning What do we have to do here??
 #endif
@@ -727,7 +748,7 @@
 	return res;
 }
 
-static int 
+static int
 fb_release(struct inode *inode, struct file *file)
 {
 	int fbidx = GET_FB_IDX(inode->i_rdev);
@@ -776,13 +797,14 @@
 	char name_buf[8];
 	static int fb_ever_opened[FB_MAX];
 	static int first = 1;
-
 	if (num_registered_fb == FB_MAX)
 		return -ENXIO;
 	num_registered_fb++;
+
 	for (i = 0 ; i < FB_MAX; i++)
 		if (!registered_fb[i])
 			break;
+
 	fb_info->node = MKDEV(FB_MAJOR, i);
 	registered_fb[i] = fb_info;
 	if (!fb_ever_opened[i]) {
@@ -859,7 +881,7 @@
  *
  */
 
-void __init 
+void __init
 fbmem_init(void)
 {
 	int i;
@@ -907,7 +929,7 @@
 
     if (!options || !*options)
 	    return 0;
-	    
+
     if (!strncmp(options, "scrollback:", 11)) {
 	    options += 11;
 	    if (*options) {
@@ -933,7 +955,7 @@
 		    }
 	    return 0;
     }
-    
+
     if (!strncmp(options, "vc:", 3)) {
 	    options += 3;
 	    if (*options)
Index: drivers/video/g364fb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/g364fb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/g364fb.c	22 Jul 2004 19:50:22 -0000	1.1
+++ drivers/video/g364fb.c	4 Aug 2004 01:29:58 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: g364fb.c,v 1.1 2004/07/22 19:50:22 joff Exp $
+/* $Id: g364fb.c,v 1.2 2004/08/04 01:29:58 joff Exp $
  *
  * linux/drivers/video/g364fb.c -- Mips Magnum frame buffer device
  *
Index: drivers/video/hgafb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/hgafb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/hgafb.c	22 Jul 2004 19:50:23 -0000	1.1
+++ drivers/video/hgafb.c	4 Aug 2004 01:29:58 -0000	1.2
@@ -704,7 +704,7 @@
 int __init hgafb_init(void)
 {
 	if (! hga_card_detect()) {
-		printk(KERN_ERR "hgafb: HGA card not detected.\n");
+		printk(KERN_INFO "hgafb: HGA card not detected.\n");
 		return -EINVAL;
 	}
 
Index: drivers/video/hitfb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/hitfb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/hitfb.c	22 Jul 2004 19:50:23 -0000	1.1
+++ drivers/video/hitfb.c	4 Aug 2004 01:29:58 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: hitfb.c,v 1.1 2004/07/22 19:50:23 joff Exp $
+ * $Id: hitfb.c,v 1.2 2004/08/04 01:29:58 joff Exp $
  * linux/drivers/video/hitfb.c -- Hitachi LCD frame buffer device
  * (C) 1999 Mihai Spatar
  * (C) 2000 YAEGASHI Takeshi
Index: drivers/video/iga.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/iga.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/iga.h	22 Jul 2004 19:50:22 -0000	1.1
+++ drivers/video/iga.h	4 Aug 2004 01:29:58 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: iga.h,v 1.1 2004/07/22 19:50:22 joff Exp $
+/* $Id: iga.h,v 1.2 2004/08/04 01:29:58 joff Exp $
  * iga1682.h: Sparc/PCI iga1682 driver constants etc.
  *
  * Copyleft 1998 V. Roganov and G. Raiko
Index: drivers/video/leofb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/leofb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/leofb.c	22 Jul 2004 19:50:22 -0000	1.1
+++ drivers/video/leofb.c	4 Aug 2004 01:29:58 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: leofb.c,v 1.1 2004/07/22 19:50:22 joff Exp $
+/* $Id: leofb.c,v 1.2 2004/08/04 01:29:58 joff Exp $
  * leofb.c: Leo (ZX) 24/8bit frame buffer driver
  *
  * Copyright (C) 1996-1999 Jakub Jelinek (jj@ultra.linux.cz)
Index: drivers/video/macfb.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/video/macfb.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/video/macfb.c	22 Jul 2004 19:50:22 -0000	1.1
+++ drivers/video/macfb.c	4 Aug 2004 01:29:58 -0000	1.2
@@ -839,7 +839,7 @@
 	fb_set_cmap:	macfb_set_cmap,
 };
 
-void __init macfb_setup(char *options, int *ints)
+void __init macfb_setup(char *options)
 {
 	char *this_opt;
 	
